clear all
clc

m = 18900;                                  % ƽ̨[kg]
Jx= 35200;                                  % xת[kg*m^2]
Jy = 30650;                                 % yת[kg*m^2]
Jz = 32600;                                 % zת[kg*m^2]

k1y = 1* 931.8 * 1000;                      % k1yնȣ޸ĲͬնȾ޸
k3y = 931.8 * 1000;                        
k2y = 1* 1242.4 * 1000;                      % k2yնȣ޸ĲͬնȾ޸  
k4y = 1242.4 * 1000;
Tf0=[-0.2;0;0];                              % ʼ  
                            
[k1x,k1z,k3x,k3z] = deal(353.01 * 1000);    % ɸն[N/m]
[k2x,k2z,k4x,k4z] = deal(470.68 * 1000);    % ɸն[N/m]
omeg = 93.12;                               % Ƶ[rad/s],14.82Hz
[r1,r3] = deal(3);                          % ͼֽó[m]
[r2,r4] = deal(3);
[alph1,alph3] = deal(acos(1.8/r1));         % ͼֽó[rad]
[alph2,alph4] = deal(acos(1.8/r2));
alph11=alph1/pi*180;
f0 = 1800000;                               % [N]
betax = pi/4;                               % xн[rad]
betay = pi/4;                               % yн[rad]
betaz = pi/2;                               % zн[rad]
%g=9.8;                                     %ٶ[m/s^2]
c1 = r1 * cos(alph1);
c2 = r2 * cos(alph2);
c3 = r3 * cos(alph3);
c4 = r4 * cos(alph4);
s1 = r1 * sin(alph1);
s2 = r2 * sin(alph2);
s3 = r3 * sin(alph3);
s4 = r4 * sin(alph4);

% /////////////////////  ///////////////////
M_v = [m m m Jx Jy Jz];   
M = diag(M_v,0);                            
% ///////////////////// նȾ ////////////////////////////
K11 = k1x + k2x + k3x + k4x;
K15 = -k1x*c1 - k2x*c2 + k3x*c3 + k4x*c4;
K22 = k1y + k2y + k3y - k4y;
K24 = k1y*c1 + k2y*c2 - k3y*c3 + k4y*c4;
K26 = k1y*s1 - k2y*s2 + k3y*s3 + k4y*s4;
K33 = k1z + k2z + k3z + k4z;
K35 = -k1z*s1 + k2z*s2 - k3z*s3 + k4z*s4;
K42 = k1y*c1 + k2y*c2 - k3y*c3 - k4y*c4;
K44 = k1y*c1^2 + k2y*c2^2 + k3y*c3^2 + k4y*c4^2;
K46 = k1y*c1*s1 - k2y*c2*s2 - k3y*c3*s3 + k4y*c4*s4;
K51 = -k1x*c1 - k2x*c2 + k3x*c3 + k4x*c4;
K53 = -k1z*s1 + k2z*s2 - k3z*s3 + k4z*s4;
K55 = k1x*c1^2 + k2x*c2^2 + k3x*c3^2 + k4x*c4^2 + k1z*s1^2 + ...
      k2z*s2^2 + k3z*s3^2 + k4z*s4^2;
K62 = k1y*s1 - k2y*s2 + k3y*s3 - k4y*s4;
K64 = k1y*c1*s1 - k2y*c2*s2 - k3y*c3*s3 + k4y*c4*s4;
K66 = k1y*s1^2 + k2y*s2^2 + k3y*s3^2 + k4y*s4^2;
K_1 = [K11 0 0 0 K15 0];
K_2 = [0 K22 0 K24 0 K26];
K_3 = [0 0 K33 0 K35 0];
K_4 = [0 K42 0 K44 0 K46];
K_5 = [K51 0 K53 0 K55 0];
K_6 = [0 K62 0 K64 0 K66];
K = [K_1;K_2;K_3;K_4;K_5;K_6];
% ///////////////////// Ч ///////////////////
C = 0.02* M + 0.02* K;
% ///////////////////// ʼλ ʼٶ /////////////
x0 = [0;0;0;0;0;0];
v0 = [0;0;0;0;0;0];
% ///////////////////// ʼ 뼤 /////////////
%f2=-m*g;f1=0;f3=0;f4=0;f5=0;f6=0;  %񶯣
fx = f0 * cos(betax);
fy = f0 * cos(betay);
fz = f0 * 0;
F0 = [0;0;0;0;0;0];                         % ʼʱ̼Ϊ0
% ///////////////////// ....... ////////////////////////////
aa0 = M \ (F0 - C * v0 - K * x0);           % ʼٶ
%aa0 =[0;0;0;0;0;0];
tm = 20;                                    % ʱΪ20
dt = 1/10240;                               % 沽
nt = tm / dt;                               % 
xx = [x0,zeros(6,nt)];                      % λ
vv = [v0,zeros(6,nt)];                      % ٶ
aa = [aa0,zeros(6,nt)];                     % ٶ
T = 0:dt:tm;                                % ʱ
Alfa = 0.25;                                % NewmarkҪ
Beta = 0.5;

% //////////// ֳ /////////////
a0 = 1 / Alfa / dt / dt;
a1 = Beta / Alfa / dt;
a2 = 1 / Alfa / dt;
a3 = 1 / 2 / Alfa - 1;
a4 = Beta / Alfa - 1;
a5 = dt / 2 * (Beta / Alfa - 2);
a6 = dt * (1 - Beta);
a7 = dt * Beta;

Ke = K + a0 * M + a1 * C;

for i = 2:nt+1
    t = (i - 1) * dt;
    
    x0 = xx(1,(i-1));                        %λx
    y0 = xx(2,(i-1));                        %λy
    z0 = xx(3,(i-1));                        %λz
    gama0 = xx(4,(i-1));                     %λgama
    phi0 = xx(5,(i-1));                      %λphi
    theta0 = xx(6,(i-1));                    %λtheta
    
    %%/////////////ת/////////////
    Tx0 = [1 0 0;...
      0 cos(gama0) sin(gama0);...
      0 -sin(gama0) cos(gama0)];
    Ty0 = [cos(phi0) 0 -sin(phi0);...
      0 1 0;...
      sin(phi0) 0 cos(phi0)];
    Tz0 = [cos(theta0) sin(theta0) 0;...
      -sin(theta0) cos(theta0) 0;...
      0 0 1];  
    R0 = Tz0 * Ty0 * Tx0;                             %ת
    
    %%/////////////󷴶Գƾ/////////////           
     
    B(:,i) = [x0;y0;z0]+R0*Tf0;       
    A=B(:,i);
    Tf=[0 -A(3,:) A(2,:);A(3,:) 0 -A(1,:);-A(2,:) A(1,:) 0];   %Գƾ
    
    %%////////////////////////// 
    Ff= R0* [fx;fy;fz];                            % ת
    Mf = Tf * Ff;                                  %
    %Mx = Mf(1,:);
    %My = Mf(2,:);
    %Mz = Mf(3,:);
    F_dt = [Ff*sin(omeg * t);Mf*sin(omeg * t)];                              %
    
    %%/////////////λ/////////////
    Fe = F_dt + M * (a0 * xx(:,i-1) + a2 * vv(:,i-1) + ...
        a3 * aa(:,i-1)) + C * (a1 * xx(:,i-1) + ...
        a4 * vv(:,i-1) + a5 * aa(:,i-1));                                    % tʱЧغ
    
    xx(:,i) = Ke \ Fe;                                                       % tʱ̵λ
    vv(:,i) = vv(:,i-1) + a6 * aa(:,i-1) + a7 * aa(:,i);                     % tʱ̵ٶ
    aa(:,i) = a0 * (xx(:,i) - xx(:,i-1)) - a2 * vv(:,i-1) - a3 * aa(:,i-1);  % tʱ̵ļٶ
    
    %%/////////////֧λ/////////////
    X=xx(:,i);                         %λ
    x = X(1,1);                        %λx
    y = X(2,1);                        %λy
    z =  X(3,1);                       %λz
    gama = X(4,1);                     %λgama
    phi =  X(5,1);                     %λphi
    theta =X(6,1);                     %λtheta
   
    Tx = [1 0 0;...
      0 cos(gama) sin(gama);...
      0 -sin(gama) cos(gama)];
    Ty = [cos(phi) 0 -sin(phi);...
      0 1 0;...
      sin(phi) 0 cos(phi)];
    Tz = [cos(theta) sin(theta) 0;...
      -sin(theta) cos(theta) 0;...
      0 0 1];  
    R  = Tz * Ty * Tx;                          %ת
        
    D_k1(:,i) = [x;y;z]+(R-eye(3))*[-s1;0;c1];  %1֧λ
    D_k2(:,i) = [x;y;z]+(R-eye(3))*[s2;0;c2];   %2֧λ
    D_k3(:,i) = [x;y;z]+(R-eye(3))*[-s3;0;-c3]; %3֧λ
    D_k4(:,i) = [x;y;z]+(R-eye(3))*[s4;0;-c4];  %4֧λ
       
end

x_k1 = 1000 * D_k1(1,:);         
y_k1 = 1000 * D_k1(2,:); 
z_k1 = 1000 * D_k1(3,:);               

x_k2 = 1000 * D_k2(1,:);
y_k2 = 1000 * D_k2(2,:);
z_k2 = 1000 * D_k2(3,:);

x_k3 = 1000 * D_k3(1,:);
y_k3 = 1000 * D_k3(2,:);
z_k3 = 1000 * D_k3(3,:);

x_k4 = 1000 * D_k4(1,:);
y_k4 = 1000 * D_k4(2,:);
z_k4 = 1000 * D_k4(3,:);


close all
% //////////// λ //////////////////
figure(1)
subplot(1,2,1)
hold on
plot(T,xx(1,:) * 1000,'blue');  %xλƣmmm
plot(T,xx(2,:) * 1000,'red');  %yλƣmmm
plot(T,xx(3,:) * 1000,'green');  %xλƣmmm
hold off
axis([0 15 -60 60])
xlabel(['\fontsize{10}\fontname{Times new roman}t(s)']);% x
ylabel(['\fontsize{10}\fontname{Times new roman}Translational displacements(mm)']);%y
set(gca,'FontName','Times New Roman','FontSize',10);%
h=legend({'{\it{x}}','{\it{y}}','{\it{z}}'},'Location','southeast','Orientation','vertical ');%northOutside
%newPosition = [0.3 0.79 0.44 0.3];
%newUnits = 'normalized';
%set(h,'Position', newPosition,'Units', newUnits);
set(h,'Fontsize',10,'Orientation','vertical ','FontName','Times New Roman');
set(gca,'Position',[0.01 0.01 0.8 0.8]);

subplot(1,2,2)
hold on
plot(T,xx(6,:));  %zתλƣmmm,'Cyan'
plot(T,xx(5,:));  %zתλƣmmm
plot(T,xx(4,:),':');  %zתλƣmmm
hold off
axis([0 15 -0.006 0.006])
xlabel(['\fontsize{10}\fontname{Times new roman}t(s)']);% x
ylabel(['\fontsize{10}\fontname{Times new roman}Rotational angular displacements(rad)']);%y
set(gca,'FontName','Times New Roman','FontSize',10);%
h=legend({'{\it{\theta}}','{\it{\phi}}','{\it{\gamma}}'},'Location','southeast');%northOutside
set(h,'Fontsize',10,'Orientation','vertical ','FontName','Times New Roman');
set(gca,'Position',[0.59 0.25 0.18 0.6]);

set(gcf,'PaperUnits','inches','PaperPosition',[0 0 15 5])%ñͼƬС
print -djpeg 1.1޹λSCI.jpg -r600%ñͼƬ
%print K1.eps -depsc2 -r600%-depsc2ʾepsͼ-r600ʾֱΪ600dpi


%//////////////////////ȡźţȶн׶ε/////////////

A1=size(xx(1,:));
t1=1;                       %ȡ1sź
T1=(tm-t1):dt:tm;
B2=size(T1);
AX=xx(1,(204801-10241+1):204801);
AY=xx(2,(204801-10241+1):204801);
AZ=xx(3,(204801-10241+1):204801);
AGAMA=xx(4,(204801-10241+1):204801);
APHI=xx(5,(204801-10241+1):204801);
ATHETA=xx(6,(204801-10241+1):204801);

A_X = 1000*(abs(max(AX)) + abs(min(AX)));  % xȶֵ
A_Y = 1000*(abs(max(AY)) + abs(min(AY)));  % yȶֵ
A_beta =atan(A_Y/A_X)/pi*180;                     % 񶯷ȶֵ
A_THETA= (abs(max(ATHETA)) + abs(min(ATHETA)))/2;  % yȶֵ
A_lamda=sqrt((A_X)^2+(A_Y)^2);

figure(2)
subplot(1,3,1)
plot(T1,AX* 1000);  %xλƣmmm
xlabel(['\fontsize{10}\fontname{Times new roman}t/s']);% x
ylabel(['\fontsize{10}\fontname{Times new roman}{\it{x}}/mm']);%y
set(gca,'FontName','Times New Roman','FontSize',10);%
axis([19 20 -6 6])

subplot(1,3,2)
plot(T1,AY * 1000);  %yλƣmmm
xlabel(['\fontsize{10}\fontname{Times new roman}t/s']);% x
ylabel(['\fontsize{10}\fontname{Times new roman}{\it{y}}/mm']);%y
set(gca,'FontName','Times New Roman','FontSize',10);%
axis([19 20 -6 6])

subplot(1,3,3)
plot(T1,ATHETA);  %zתλ
xlabel(['\fontsize{10}\fontname{Times new roman}t/s']);% x
ylabel(['\fontsize{10}\fontname{Times new roman}{\it\theta}/rad']);%y
set(gca,'FontName','Times New Roman','FontSize',10);%
axis([19 20 -0.0006 0.0006])

set(gcf,'PaperUnits','inches','PaperPosition',[0 0 6.7 2])%ñͼƬС
print -djpeg 1.2޹ȶλ.jpg -r600%ñͼƬ
save xx